#include <linux/kernel.h>
#include <linux/malloc.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/usb.h>
#include <asm/uaccess.h>

MODULE_AUTHOR("yaz");
MODULE_DESCRIPTION("USB HUBCOT driver");


//ޥ
//major 180, minor 100˥ޥåפ롣100ʳˤϲѹ
#define TORO_MINOR 100
//ǥեȤư1λ֡ñ mSec
#define TORO_DEFAULT_PERIOD 200


//ȥΥǡ¤
typedef struct usb_toro {
	struct usb_device *usbdev;
	devrequest dr;		//ꥯȡȥ˽Ŷ
	int opened;		//ե󥹥
	wait_queue_head_t remove_ok;	//disconnect waitqueue
} usb_toro_t; 	

usb_toro_t *gtoro = NULL;

//prototype
static void do_pause(int times);
static void do_send(void);

//Ū˥ե󥹥Ȥ򸺤餹ioctlޥ
#define TORO_IOC_HARDRESET 	15
//ư֥ꥻå
#define TORO_IOC_PERIOD_RESET 	16
//ư
#define TORO_IOC_PERIOD_SET 	17

static int ioctl_toro(struct inode *inode, struct file *file,
               unsigned int cmd, unsigned long arg)
{

    switch(cmd) {
    case TORO_IOC_HARDRESET:
	    MOD_DEC_USE_COUNT;
	    break;
    case TORO_IOC_PERIOD_RESET:
	    gtoro->dr.value = TORO_DEFAULT_PERIOD;
	    break;
    case TORO_IOC_PERIOD_SET:
	    gtoro->dr.value = arg;
	    break;
    default:
	    return -ENOIOCTLCMD;
    }
    return 0;
}


static int usb_toro_open(struct inode *inode, struct file *file)
{
	
	if( (gtoro == NULL) || (gtoro->usbdev == NULL) ){	// device¸ߤʤ
		return -1;
	}

	gtoro->opened += 1;	//ե󥹥
	MOD_INC_USE_COUNT;

	return 0;
}

static int usb_toro_close(struct inode *inode, struct file *file)
{
	if(gtoro->opened){	//ե󥹥ȸ
		if(gtoro->opened == 1){ //ǸλȤλdisconnectε̲򵯤
			wake_up(&gtoro->remove_ok);
		}

		gtoro->opened -=1;
		MOD_DEC_USE_COUNT;
	}
	return 0;
}

static ssize_t read_toro(struct file *file, char *buffer, size_t count, loff_t * ppos)
{
	//ʤ⤷ʤߡ
	return (ssize_t)0;
}

static ssize_t write_toro(struct file *file, const char *buffer, size_t count, loff_t *ppos)
{
	const char *datum = buffer;
	char cmd;
	int got=0;

	if((gtoro == NULL) || (gtoro->usbdev == NULL)) {//ȴƤ롿¸ߤʤ
		return -1;
	}
	
#define TORO_GET() ({get_user(cmd, datum); datum++; count--; got++;})

	while(count){
		TORO_GET();
		switch( cmd ) {
		case 0x30:	//0	NO-OP
			gtoro->dr.request = 0x00;
			do_send();
			break;
		case 0x31:	//1	R
			gtoro->dr.request = 0x01;
			do_send();
			do_pause(2);
			break;
		case 0x32:	//2	L
			gtoro->dr.request = 0x02;
			do_send();
			do_pause(2);
			break;
		case 0x33:	//3	ξ
			gtoro->dr.request = 0x03;
			do_send();
			do_pause(2);
			break;
		case 0x34:	//4	ξx4
			gtoro->dr.request = 0x04;
			do_send();
			do_pause(8);
			break;
		case 0x35:	//5	LRLRLR
			gtoro->dr.request = 0x05;
			do_send();
			do_pause(8);
			break;
		case 0x36:	//6    	RRR
			gtoro->dr.request = 0x06;
			do_send();
			do_pause(6);
			break;
		case 0x37:	//7	LRLRLR
			gtoro->dr.request = 0x07;
			do_send();
			do_pause(8);
			break;
		case 0x38:	//8	ξx3
			gtoro->dr.request = 0x08;
			do_send();
			do_pause(6);
			break;
		case 0x39:	//9	R
			gtoro->dr.request = 0x09;
			do_send();
			do_pause(2);
			break;
		case 0x61:	//a	ξ
			gtoro->dr.request = 0x0a;
			do_send();
			do_pause(2);
			break;
		case 0x62: case 0x42:	//b	RL
			gtoro->dr.request = 0x0b;
			do_send();
			do_pause(3);
			break;
		case 0x63: case 0x43:	//c	RLRLRL
			gtoro->dr.request = 0x0c;
			do_send();
			do_pause(8);
			break;
		case 0x70: case 0x50:	//pseudo command p for pause
			do_pause(1);
			break;
		default:		
			gtoro->dr.request = 0x00;
			break;
		}
	}
	return got;

}

static void do_send()
{
	int err;

	//ȥå
	err = usb_control_msg(gtoro->usbdev, usb_sndctrlpipe(gtoro->usbdev, 0),
			      gtoro->dr.request, gtoro->dr.requesttype, gtoro->dr.value,
			      gtoro->dr.index, NULL, gtoro->dr.length, 5*HZ);
	if(err){
		dbg("usb_control_msg failed: err = %d",err);
	}
}

static void do_pause(int times)
{
	int timeout;
	
	//1ư x ꤵ줿˥ޤ򥻥åȤԤ
	timeout = (int)(gtoro->dr.value * times * HZ / 1000);
	current->state = TASK_INTERRUPTIBLE;
	timeout = schedule_timeout(timeout);
}

static void *usb_toro_probe(struct usb_device *dev, unsigned int ifnum,
			     const struct usb_device_id *id)
{

	gtoro = kmalloc(sizeof(usb_toro_t), GFP_KERNEL);

	if(gtoro == NULL) {
		// ݼ
		return NULL;
	}
	
	//usbdev
	gtoro->usbdev = dev;
	gtoro->opened = 0;

	//disconnect  wait queue
	init_waitqueue_head(&gtoro->remove_ok);
	
//	device requestȤΩƤ
//	
//	typedef struct {
//		__u8 requesttype;
//		__u8 request;
//		__u16 value;
//		__u16 index;
//		__u16 length;
//	} devrequest __attribute__ ((packed)); 
	
	gtoro->dr.requesttype = USB_TYPE_VENDOR|USB_RECIP_DEVICE|USB_DIR_OUT;
	gtoro->dr.value = TORO_DEFAULT_PERIOD;	//1ưλ֡ñ̤ms.
	gtoro->dr.index = 0;
	gtoro->dr.length = 0;

	return gtoro;
}


//USBǥХȴ˸ƤФ
static void usb_toro_disconnect(struct usb_device *dev, void *ptr)
{
	if(gtoro != NULL) {
		// ȥ˸뤿
		gtoro->usbdev = NULL;

		// ȤƤ硢ǸλȤcloseΤԤ
		if(gtoro->opened){
			sleep_on(&gtoro->remove_ok);
		}

		// ǡ¤Ѵ
		kfree(gtoro);
		gtoro = NULL;
	}
}

//ǥХǤΤ
static struct usb_device_id usb_toro_id_table [] = {
	{ USB_DEVICE(0x054d, 0x1b59) },		/* hubcot */
	{ }					/* terminating entry */
};


MODULE_DEVICE_TABLE (usb, usb_toro_id_table);


static struct file_operations usb_toro_fops = {
        read:           read_toro,
        write:          write_toro,
        ioctl:          ioctl_toro,
        open:           usb_toro_open,
        release:        usb_toro_close,
};

static struct usb_driver usb_toro_driver = {
	name:		"toro",
	probe:		usb_toro_probe,
	disconnect:	usb_toro_disconnect,
	fops:		&usb_toro_fops,
	minor:		TORO_MINOR,
	id_table:	usb_toro_id_table,
};

static int __init usb_toro_init(void)
{
	usb_register(&usb_toro_driver);
	return 0;
}

static void __exit usb_toro_exit(void)
{
	usb_deregister(&usb_toro_driver);
}

module_init(usb_toro_init);
module_exit(usb_toro_exit);
